Index: rom/bios.s
===================================================================
--- rom/bios.s	(revision f40a3096572fd1b0696a7f7c717464e68652e655)
+++ rom/bios.s	(revision 4f508e6879b14fc73a3587ac6cd023ca6262eae8)
@@ -1880,1143 +1880,1143 @@
 		add.l	#drvbpbs,a5
 		move.w	d6,(a7)
-		bsr	mediach			* Test for media change
-		move.w	d0,d7			* Save status
-		cmp.w	#2,d7			* Disk changed ?
-		bne	rwabs2			* Jump if not
-*
-		moveq.l	#ERR14,d0		* ERROR -- "media changed"
-		bra	rwabser			* ...
-*
-rwabs2:		cmp.w	#1,d7			* Disk possibly changed ?
+		bsr	mediach			| Test for media change
+		move.w	d0,d7			| Save status
+		cmp.w	#2,d7			| Disk changed ?
+		bne	rwabs2			| Jump if not
+
+		moveq.l	#ERR14,d0		| ERROR -- "media changed"
+		bra	rwabser			| ...
+
+rwabs2:		cmp.w	#1,d7			| Disk possibly changed ?
 		bne	rwabs7
-*
-rwabs3:		move.w	#1,(a7)			* floprd count = 1,
-		clr.w	-(a7)			* ... side = 0,
-		clr.w	-(a7)			* ... track = 0,
-		move.w	#1,-(a7)		* ... sector = 1,
-		move.w	d6,-(a7)		* ... drive number,
-		clr.l	-(a7)			* ... filler,
-		move.l	#buffer,-(a7)		* ... buffer address,
-		jsr	floprd			* Read boot sector
-		add.l	#16,a7			* Cleanup stack
-		move.l	d0,-4(a6)		* Save error number
-		tst.l	-4(a6)			* ... and test it
-		bge	rwabs11			* Jump if OK
-*
-		.page
-*
+
+rwabs3:		move.w	#1,(a7)			| floprd count = 1,
+		clr.w	-(a7)			| ... side = 0,
+		clr.w	-(a7)			| ... track = 0,
+		move.w	#1,-(a7)		| ... sector = 1,
+		move.w	d6,-(a7)		| ... drive number,
+		clr.l	-(a7)			| ... filler,
+		move.l	#buffer,-(a7)		| ... buffer address,
+		jsr	floprd			| Read boot sector
+		add.l	#16,a7			| Cleanup stack
+		move.l	d0,-4(a6)		| Save error number
+		tst.l	-4(a6)			| ... and test it
+		bge	rwabs11			| Jump if OK
+
+		.page
+
 		move.w	d6,(a7)
 		move.l	-4(a6),d0
 		move.w	d0,-(a7)
-		jsr	criter			* Call critical error code
-		addq.l	#2,a7			* Cleanup stack
+		jsr	criter			| Call critical error code
+		addq.l	#2,a7			| Cleanup stack
 		move.l	d0,-4(a6)
-*
+
 rwabs11:	move.l	-4(a6),d0
 		cmp.l	#RETRYIT,d0
-		beq	rwabs3			* Read again
-*
-		tst.l	-4(a6)			* Test error number
-		bge	rwabs4			* OK ?
-*
+		beq	rwabs3			| Read again
+
+		tst.l	-4(a6)			| Test error number
+		bge	rwabs4			| OK ?
+
 		move.l	-4(a6),d0
-		bra	rwabser			* ERROR
-*
-rwabs4:		clr.w	d7			* Clear media change status
+		bra	rwabser			| ERROR
+
+rwabs4:		clr.w	d7			| Clear media change status
 		bra	rwabs10
-*
-rwabs6:		move.l	#buffer,a0		* Address of sector buffer to a0
-		move.b	8(a0,d7),d0		* Serial number
+
+rwabs6:		move.l	#buffer,a0		| Address of sector buffer to a0
+		move.b	8(a0,d7),d0		| Serial number
 		ext.w	d0
-		move.b	28(a5,d7),d1		* Compare to old one
+		move.b	28(a5,d7),d1		| Compare to old one
 		ext.w	d1
 		cmp.w	d1,d0
-		beq	rwabs5			* Jump if they're the same
-*
-		moveq.l	#ERR14,d0		* ERROR -- "media changed"
+		beq	rwabs5			| Jump if they're the same
+
+		moveq.l	#ERR14,d0		| ERROR -- "media changed"
 		bra	rwabser
-*
-rwabs5:		addq.w	#1,d7			* Next byte of serial number
-*
-rwabs10:	cmp.w	#3,d7			* All 3 bytes checked ?
-		blt	rwabs6			* Loop if not
-*
-		.page
-*
-		move.w	d6,a0			* Point at wplatch for drive
-		add.l	#wplatch,a0		* ...
-		move.w	d6,a1			* Point at wpstatus for drive
-		add.l	#wpstatus,a1		* ...
-		move.b	(a1),(a0)		* Move wpstatus to wplatch
-		bne	rwabs9			* Jump if set
-*
-		move.w	d6,a0			* Set dskmode to "Unchanged"
-		add.l	#dskmode,a0		* ...
-		clr.b	(a0)			* ...
-*
-rwabs7:		tst.w	nflops			* Test nflops
+
+rwabs5:		addq.w	#1,d7			| Next byte of serial number
+
+rwabs10:	cmp.w	#3,d7			| All 3 bytes checked ?
+		blt	rwabs6			| Loop if not
+
+		.page
+
+		move.w	d6,a0			| Point at wplatch for drive
+		add.l	#wplatch,a0		| ...
+		move.w	d6,a1			| Point at wpstatus for drive
+		add.l	#wpstatus,a1		| ...
+		move.b	(a1),(a0)		| Move wpstatus to wplatch
+		bne	rwabs9			| Jump if set
+
+		move.w	d6,a0			| Set dskmode to "Unchanged"
+		add.l	#dskmode,a0		| ...
+		clr.b	(a0)			| ...
+
+rwabs7:		tst.w	nflops			| Test nflops
 		bne	rwabs8
-*
-		moveq.l	#ERR02,d0		* ERROR -- "drive not ready"
+
+		moveq.l	#ERR02,d0		| ERROR -- "drive not ready"
 		bra	rwabser
-*
-rwabs8:		cmp.w	#1,8(a6)		* Check rwflag
+
+rwabs8:		cmp.w	#1,8(a6)		| Check rwflag
 		ble	rwabs9
-*
-		subq.w	#2,8(a6)		* Adjust to 0|1
-*
-rwabs9:		move.w	14(a6),(a7)		* Setup count,
-		move.w	d6,-(a7)		* ... drive,
-		move.w	16(a6),-(a7)		* ... recno,
-		move.l	10(a6),-(a7)		* ... buffer,
-		move.w	8(a6),-(a7)		* ... rwflag
-		bsr	floprw			* Call floprw
-*
-		add.l	#10,a7			* Cleanup stack
-*
-rwabser:	tst.l	(a7)+			* Pop stack scratch
-		movem.l	(a7)+,d5-d7/a5		* Restore registers
-		unlk	a6			* Release temporaries
-		rts				* Return to caller
-*
-		.page
-*
-* floprw -- Floppy read / write driver
-* ------    --------------------------
-floprw:		link	a6,#-6			* Reserve space for temps
-		movem.l	d2-d7/a5,-(a7)		* Save registers
-		move.w	16(a6),d0		* Drive number to d0
-		asl.w	#5,d0			* Shift ( *32 )
-		ext.l	d0			* Sign extend it, too
-		move.l	d0,a5			* Result in a5
-		add.l	#drvbpbs,a5		* Add base of BPB table
-		btst	#0,13(a6)		* Buffer address even ?
-		bne	floprw01		* Jump if not
-*
-		clr.w	d0			* Clear odd flag
-		bra	floprw02		* Go save the flag
-*
-floprw01:	moveq.l	#1,d0			* Set odd flag
-*
-floprw02:	move.w	d0,-2(a6)		* Save it
-		tst.w	22(a5)			* dspc set ?
-		bne	floprw20		* Jump if so
-*
-		moveq.l	#9,d0			* Assume 9
-		move.w	d0,22(a5)		* ... and make it the default
-		move.w	d0,24(a5)		* ... for dspt and dspc
-*
+
+		subq.w	#2,8(a6)		| Adjust to 0|1
+
+rwabs9:		move.w	14(a6),(a7)		| Setup count,
+		move.w	d6,-(a7)		| ... drive,
+		move.w	16(a6),-(a7)		| ... recno,
+		move.l	10(a6),-(a7)		| ... buffer,
+		move.w	8(a6),-(a7)		| ... rwflag
+		bsr	floprw			| Call floprw
+
+		add.l	#10,a7			| Cleanup stack
+
+rwabser:	tst.l	(a7)+			| Pop stack scratch
+		movem.l	(a7)+,d5-d7/a5		| Restore registers
+		unlk	a6			| Release temporaries
+		rts				| Return to caller
+
+		.page
+
+| floprw -- Floppy read / write driver
+| ------    --------------------------
+floprw:		link	a6,#-6			| Reserve space for temps
+		movem.l	d2-d7/a5,-(a7)		| Save registers
+		move.w	16(a6),d0		| Drive number to d0
+		asl.w	#5,d0			| Shift ( |32 )
+		ext.l	d0			| Sign extend it, too
+		move.l	d0,a5			| Result in a5
+		add.l	#drvbpbs,a5		| Add base of BPB table
+		btst	#0,13(a6)		| Buffer address even ?
+		bne	floprw01		| Jump if not
+
+		clr.w	d0			| Clear odd flag
+		bra	floprw02		| Go save the flag
+
+floprw01:	moveq.l	#1,d0			| Set odd flag
+
+floprw02:	move.w	d0,-2(a6)		| Save it
+		tst.w	22(a5)			| dspc set ?
+		bne	floprw20		| Jump if so
+
+		moveq.l	#9,d0			| Assume 9
+		move.w	d0,22(a5)		| ... and make it the default
+		move.w	d0,24(a5)		| ... for dspt and dspc
+
 floprw20:	bra	floprw18
-*
-floprw03:	tst.w	-2(a6)			* Is odd flag set ?
-		beq	floprw04		* Jump if not
-*
-		move.l	#buffer,d0		* Point to sector buffer
+
+floprw03:	tst.w	-2(a6)			| Is odd flag set ?
+		beq	floprw04		| Jump if not
+
+		move.l	#buffer,d0		| Point to sector buffer
 		bra	floprw05
-*
-floprw04:	move.l	10(a6),d0		* Get buffer address
-*
-floprw05:	move.l	d0,-6(a6)		* ... and save
-		move.w	14(a6),d6		* Get recno  (lsn)
-		ext.l	d6			* Extend it to long
-		divs.w	22(a5),d6		* Divide by dspc for track #
-		move.w	14(a6),d4		* Get recno
-		ext.l	d4			* Extend to long
-		divs.w	22(a5),d4		* Divide by dspc
-		swap	d4			* Use remainder as sector number
-		cmp.w	24(a5),d4		* Compare with dspt
-		bge	floprw06		* Greater than or equal ?
-*
-		clr.l	d5			* Use side 0
+
+floprw04:	move.l	10(a6),d0		| Get buffer address
+
+floprw05:	move.l	d0,-6(a6)		| ... and save
+		move.w	14(a6),d6		| Get recno  (lsn)
+		ext.l	d6			| Extend it to long
+		divs.w	22(a5),d6		| Divide by dspc for track #
+		move.w	14(a6),d4		| Get recno
+		ext.l	d4			| Extend to long
+		divs.w	22(a5),d4		| Divide by dspc
+		swap	d4			| Use remainder as sector number
+		cmp.w	24(a5),d4		| Compare with dspt
+		bge	floprw06		| Greater than or equal ?
+
+		clr.l	d5			| Use side 0
 		bra	floprw07
-*
-floprw06:	moveq.l	#1,d5			* Use side 1
-		sub.w	24(a5),d4		* Subtract dspt from sector #
-*
-		.page
-*
-floprw07:	tst.w	-2(a6)			* Is odd flag set ?
-		beq	floprw08		* Jump if not
-*
-		moveq.l	#1,d3			* Set counter to 1
+
+floprw06:	moveq.l	#1,d5			| Use side 1
+		sub.w	24(a5),d4		| Subtract dspt from sector #
+
+		.page
+
+floprw07:	tst.w	-2(a6)			| Is odd flag set ?
+		beq	floprw08		| Jump if not
+
+		moveq.l	#1,d3			| Set counter to 1
 		bra	floprw10
-*
-floprw08:	move.w	24(a5),d0		* Get dspt
-		sub.w	d4,d0			* Subtract sector number
-		cmp.w	18(a6),d0		* Compare with number of sectors
-		bge	floprw09		* Jump if greater than or eq to
-*
-		move.w	24(a5),d3		* Get dspt
-		sub.w	d4,d3			* Subtract sector number
+
+floprw08:	move.w	24(a5),d0		| Get dspt
+		sub.w	d4,d0			| Subtract sector number
+		cmp.w	18(a6),d0		| Compare with number of sectors
+		bge	floprw09		| Jump if greater than or eq to
+
+		move.w	24(a5),d3		| Get dspt
+		sub.w	d4,d3			| Subtract sector number
 		bra	floprw10
-*
-floprw09:	move.w	18(a6),d3		* Count = number of sectors
-*
-floprw10:	addq.w	#1,d4			* Adjust sector number (1 org)
-*
-floprw11:	tst.w	8(a6)			* Test r/w flag
-		beq	floprw14		* Jump if it's a read
-*
-		move.l	-6(a6),d0		* Get buffer pointer
-		cmp.l	10(a6),d0		* See if it's = buffer addr
-		beq	floprw12		* Jump if so
-*
-		move.l	-6(a6),(a7)		* Get source address
-		move.l	10(a6),-(a7)		* Destination address
-		jsr	fastcopy		* Copy the sector
-		addq.l	#4,a7			* Cleanup stack
-*
-floprw12:	move.w	d3,(a7)			* Number of sectors
-		move.w	d5,-(a7)		* Side number
-		move.w	d6,-(a7)		* Track number
-		move.w	d4,-(a7)		* Sector number
-		move.w	16(a6),-(a7)		* Drive number
-		clr.l	-(a7)			* Filler
-		move.l	-6(a6),-(a7)		* Buffer address
-		jsr	flopwr			* Write sector
-		add.l	#16,a7			* Cleaup stack
-		move.l	d0,d7			* Save error code in d7
-		tst.l	d7			* Errors ?
-		bne	floprw13		* Jump if so
-*
-		.page
-*
-		tst.w	fverify			* Verify after write ?
-		beq	floprw13		* Jump if not
-*
-		move.w	d3,(a7)			* Number of sectors
-		move.w	d5,-(a7)		* Side number
-		move.w	d6,-(a7)		* Track number
-		move.w	d4,-(a7)		* Sector number
-		move.w	16(a6),-(a7)		* Drive number
-		clr.l	-(a7)			* Filler
-		move.l	#buffer,-(a7)		* Buffer address
-		jsr	flopver			* Verify sector(s)
-		add.l	#16,a7			* Cleanup stack
-		move.l	d0,d7			* Save error code in d7
-		tst.l	d7			* Errors ?
-		bne	floprw13		* Jump if so
-*
-		move.l	#buffer,(a7)		* Address of sector buffer
-		bsr	itom			* Convert first word of buffer
-		tst.w	d0			* Bad sectors ?
-		beq	floprw13		* Jump if not
-*
-		moveq.l	#ERR16,d7		* ERROR -- "Bad sectors"
-*
+
+floprw09:	move.w	18(a6),d3		| Count = number of sectors
+
+floprw10:	addq.w	#1,d4			| Adjust sector number (1 org)
+
+floprw11:	tst.w	8(a6)			| Test r/w flag
+		beq	floprw14		| Jump if it's a read
+
+		move.l	-6(a6),d0		| Get buffer pointer
+		cmp.l	10(a6),d0		| See if it's = buffer addr
+		beq	floprw12		| Jump if so
+
+		move.l	-6(a6),(a7)		| Get source address
+		move.l	10(a6),-(a7)		| Destination address
+		jsr	fastcopy		| Copy the sector
+		addq.l	#4,a7			| Cleanup stack
+
+floprw12:	move.w	d3,(a7)			| Number of sectors
+		move.w	d5,-(a7)		| Side number
+		move.w	d6,-(a7)		| Track number
+		move.w	d4,-(a7)		| Sector number
+		move.w	16(a6),-(a7)		| Drive number
+		clr.l	-(a7)			| Filler
+		move.l	-6(a6),-(a7)		| Buffer address
+		jsr	flopwr			| Write sector
+		add.l	#16,a7			| Cleaup stack
+		move.l	d0,d7			| Save error code in d7
+		tst.l	d7			| Errors ?
+		bne	floprw13		| Jump if so
+
+		.page
+
+		tst.w	fverify			| Verify after write ?
+		beq	floprw13		| Jump if not
+
+		move.w	d3,(a7)			| Number of sectors
+		move.w	d5,-(a7)		| Side number
+		move.w	d6,-(a7)		| Track number
+		move.w	d4,-(a7)		| Sector number
+		move.w	16(a6),-(a7)		| Drive number
+		clr.l	-(a7)			| Filler
+		move.l	#buffer,-(a7)		| Buffer address
+		jsr	flopver			| Verify sector(s)
+		add.l	#16,a7			| Cleanup stack
+		move.l	d0,d7			| Save error code in d7
+		tst.l	d7			| Errors ?
+		bne	floprw13		| Jump if so
+
+		move.l	#buffer,(a7)		| Address of sector buffer
+		bsr	itom			| Convert first word of buffer
+		tst.w	d0			| Bad sectors ?
+		beq	floprw13		| Jump if not
+
+		moveq.l	#ERR16,d7		| ERROR -- "Bad sectors"
+
 floprw13:	bra	floprw15
-*
-		.page
-*
-floprw14:	move.w	d3,(a7)			* Number of sectors
-		move.w	d5,-(a7)		* Side number
-		move.w	d6,-(a7)		* Track number
-		move.w	d4,-(a7)		* Sector number
-		move.w	16(a6),-(a7)		* Drive number
-		clr.l	-(a7)			* Filler
-		move.l	-6(a6),-(a7)		* Sector buffer
-		jsr	floprd			* Read floppy sector(s)
-		add.l	#16,a7			* Cleanup stack
-		move.l	d0,d7			* Save error code in d7
-		move.l	-6(a6),d0		* User buffer address
-		cmp.l	10(a6),d0		* Is it the desired buffer ?
-		beq	floprw15		* Jump if so
-*
-		move.l	10(a6),(a7)		* Push source address
-		move.l	-6(a6),-(a7)		* Push destination address
-		jsr	fastcopy		* Copy the sector
-		addq.l	#4,a7			* Cleanup stack
-*
-floprw15:	tst.l	d7			* Error code set ?
-		bge	floprw16		* Jump if not
-*
-		move.w	16(a6),(a7)		* Push drive number
-		move.l	d7,d0			* Error code
-		move.w	d0,-(a7)		* ... onto stack
-		jsr	criter			* Call critical error handler
-		addq.l	#2,a7			* Cleanup stack
-		move.l	d0,d7			* Get error code
-*
-floprw16:	cmp.l	#RETRYIT,d7		* Re-try ?
-		beq	floprw11		* Jump if so
-*
-		tst.l	d7			* Check error code
-		bge	floprw17		* Jump if no error
-*
-		move.l	d7,d0			* Error code is the result
+
+		.page
+
+floprw14:	move.w	d3,(a7)			| Number of sectors
+		move.w	d5,-(a7)		| Side number
+		move.w	d6,-(a7)		| Track number
+		move.w	d4,-(a7)		| Sector number
+		move.w	16(a6),-(a7)		| Drive number
+		clr.l	-(a7)			| Filler
+		move.l	-6(a6),-(a7)		| Sector buffer
+		jsr	floprd			| Read floppy sector(s)
+		add.l	#16,a7			| Cleanup stack
+		move.l	d0,d7			| Save error code in d7
+		move.l	-6(a6),d0		| User buffer address
+		cmp.l	10(a6),d0		| Is it the desired buffer ?
+		beq	floprw15		| Jump if so
+
+		move.l	10(a6),(a7)		| Push source address
+		move.l	-6(a6),-(a7)		| Push destination address
+		jsr	fastcopy		| Copy the sector
+		addq.l	#4,a7			| Cleanup stack
+
+floprw15:	tst.l	d7			| Error code set ?
+		bge	floprw16		| Jump if not
+
+		move.w	16(a6),(a7)		| Push drive number
+		move.l	d7,d0			| Error code
+		move.w	d0,-(a7)		| ... onto stack
+		jsr	criter			| Call critical error handler
+		addq.l	#2,a7			| Cleanup stack
+		move.l	d0,d7			| Get error code
+
+floprw16:	cmp.l	#RETRYIT,d7		| Re-try ?
+		beq	floprw11		| Jump if so
+
+		tst.l	d7			| Check error code
+		bge	floprw17		| Jump if no error
+
+		move.l	d7,d0			| Error code is the result
 		bra	floprw19
-*
-		.page
-*
-floprw17:	move.w	d3,d0			* Sector counter to d0
-		ext.l	d0			* Sign extend
-		moveq.l	#9,d1			* Times 512
-		asl.l	d1,d0			* ...
-		add.l	d0,10(a6)		* Update buffer address
-		add.w	d3,14(a6)		* Update sector number
-		sub.w	d3,18(a6)		* Update sector count
-*
-floprw18:	tst.w	18(a6)			* More sectors ?
-		bne	floprw03		* Jump if so
-*
-		clr.l	d0			* Set "no error" as result
-*
-floprw19:	tst.l	(a7)+			* Test top of stack
-		movem.l	(a7)+,d3-d7/a5		* Restore registers
-		unlk	a6			* Release stack space
-		rts				* Return to caller
-*
-		.page
-*
-* itom -- Convert 8086 integer format to 680000 integer format
-* ----    ----------------------------------------------------
-itom:		link	a6,#-4			* Reserve stack for temps
-		move.l	8(a6),a0		* Address of the number to a0
-		move.b	1(a0),d0		* Get high byte
-		ext.w	d0			* Make it a word
-		and.w	#$FF,d0			* Isolate bits 0..7
-		asl.w	#8,d0			* Shift in bits 8..15
-		move.l	8(a6),a1		* Address of the number to a1
-		move.b	(a1),d1			* Get low byte
-		ext.w	d1			* Extend to word
-		and.w	#$FF,d1			* Isolate bits 0..7
-		or.w	d1,d0			* Combine with bits 8..15
-		unlk	a6			* Release stack space
-		rts				* Return to caller
-*
-		.page
-*
-* flopini -- Initialize floppy drive
-* -------    -----------------------
-flopini:	lea	dsb0,a1			* Point to dsb for drive A
-		tst.w	12(a7)			* Drive A wanted ?
-		beq	flopin01		* Jump if so
-*
-		lea	dsb1,a1			* Drive B dsb address to a1
-*
-flopin01:	move.w	seekrate,2(a1)		* Get seek rate
-		moveq.l	#ERR01,d0		* Set default error number
-		clr.w	0(a1)			* Set track number to 0
-		bsr	floplock		* Setup floppy parameters
-		bsr	select			* Select drive and side
-		move.w	#$FF00,0(a1)
-		bsr	restore			* Restore the drive
+
+		.page
+
+floprw17:	move.w	d3,d0			| Sector counter to d0
+		ext.l	d0			| Sign extend
+		moveq.l	#9,d1			| Times 512
+		asl.l	d1,d0			| ...
+		add.l	d0,10(a6)		| Update buffer address
+		add.w	d3,14(a6)		| Update sector number
+		sub.w	d3,18(a6)		| Update sector count
+
+floprw18:	tst.w	18(a6)			| More sectors ?
+		bne	floprw03		| Jump if so
+
+		clr.l	d0			| Set "no error" as result
+
+floprw19:	tst.l	(a7)+			| Test top of stack
+		movem.l	(a7)+,d3-d7/a5		| Restore registers
+		unlk	a6			| Release stack space
+		rts				| Return to caller
+
+		.page
+
+| itom -- Convert 8086 integer format to 680000 integer format
+| ----    ----------------------------------------------------
+itom:		link	a6,#-4			| Reserve stack for temps
+		move.l	8(a6),a0		| Address of the number to a0
+		move.b	1(a0),d0		| Get high byte
+		ext.w	d0			| Make it a word
+		and.w	#0xFF,d0		| Isolate bits 0..7
+		asl.w	#8,d0			| Shift in bits 8..15
+		move.l	8(a6),a1		| Address of the number to a1
+		move.b	(a1),d1			| Get low byte
+		ext.w	d1			| Extend to word
+		and.w	#0xFF,d1		| Isolate bits 0..7
+		or.w	d1,d0			| Combine with bits 8..15
+		unlk	a6			| Release stack space
+		rts				| Return to caller
+
+		.page
+
+| flopini -- Initialize floppy drive
+| -------    -----------------------
+flopini:	lea	dsb0,a1			| Point to dsb for drive A
+		tst.w	12(a7)			| Drive A wanted ?
+		beq	flopin01		| Jump if so
+
+		lea	dsb1,a1			| Drive B dsb address to a1
+
+flopin01:	move.w	seekrate,2(a1)		| Get seek rate
+		moveq.l	#ERR01,d0		| Set default error number
+		clr.w	0(a1)			| Set track number to 0
+		bsr	floplock		| Setup floppy parameters
+		bsr	select			| Select drive and side
+		move.w	#0xFF00,0(a1)
+		bsr	restore			| Restore the drive
 		moveq.l	#6,d7
 		bsr	hseek1
 		bne	flopin02
-*
-		bsr	restore			* Restore the drive
-		beq	flopok			* Jump if no error
-*
-flopin02:	bra	flopfail		* Jump to error handler
-*
-		.page
-*
-* floprd -- Read floppy
-* ------    -----------
-floprd:		bsr	change			* Disk changed ?
-		moveq.l	#ERR11,d0		* Set to "read error"
-		bsr	floplock		* Set parameters
-*
-floprd01:	bsr	select			* Select drive and side
-		bsr	go2track		* Position on track
-		bne	floprd02		* Try again on error
-*
-		move.w	#ERR01,deferr		* Set default error
-		move.l	edma(a5),a0		* Get final DMA address
-		move.l	cdma(a5),a2		* Get first DMA address
-		move.l	#$40000,d7		* Set timeout counter
-		move.b	#FL_RM,DSKCMD(a6)	* Start readng the disk
-*
-floprd03:	btst	#0,DSKCMD(a6)		* Disk busy yet ?
-		bne	floprd05		* Jump if so
-*
-		subq.l	#1,d7			* Decrement timeout counter
-		beq	floprd04		* Jump if timed out
-*
-		bra	floprd03		* Go try for busy again
-*
-floprd05:	move.l	#$40000,d7		* Reset timeout counter
-		bra	floprd09		* Go join main read loop
-*
-floprd07:	subq.l	#1,d7			* Decrement timeout counter
-		beq	floprd04		* Jump if timed out
-*
-		btst	#0,DSKCMD(a6)		* Done yet ?
-		beq	floprd08		* Jump if so
-*
-floprd09:	btst	#1,DSKCMD(a6)		* DRQ set ?
-		beq	floprd07		* Jump if not
-*
-		move.b	DSKDAT(a6),(a2)+	* Read the byte into the buffer
-		cmp.l	a0,a2			* Done reading ?
-		bne	floprd07		* Jump if not
-*
-		.page
-*
-floprd08:	move.b	DSKCMD(a6),d0		* Read final status into d0
-		and.b	#$1C,d0			* Mask for error bits
-		beq	flopok			* Jump if no errors
-*
-		bsr	errbits			* Determine error code
-*
-floprd02:	cmp.w	#1,retrycnt(a5)		* Re-try ?
-		bne	floprd06		* Jump if not
-*
-		bsr	reseek			* Home and repeat the seek
-*
-floprd06:	subq.w	#1,retrycnt(a5)		* Update re-try count
-		bpl	floprd01		* Re-try if count still >0
-*
-		bra	flopfail		* Failure
-*
-floprd04:	move.w	#ERR02,curerr(a5)	* Set error code "not ready"
-		bsr	rs1772			* Reset the WD1772
-		bra	floprd02		* See if it can be retried
-*
-		.page
-*
-* errbits -- Develop error code for floppy I/O error
-* -------    ---------------------------------------
-errbits:	moveq.l	#ERR13,d1		* Write protect ?
-		btst	#6,d0			* ...
-		bne	errbits1		* Jump if so
-*
-		moveq.l	#ERR08,d1		* Record not found ?
-		btst	#4,d0			* ...
-		bne	errbits1		* Jump if so
-*
-		moveq.l	#ERR04,d1		* CRC error ?
-		btst	#3,d0			* ...
-		bne	errbits1		* Jump if so
-*
-		moveq.l	#ERR12,d1		* Lost data ?
-		btst	#2,d0			* ...
-		bne	errbits1		* Jump if so
-*
-		move.w	deferr(a5),d1		* Use default error
-*
-errbits1:	move.w	d1,curerr(a5)		* ... as curerr
-		rts				* Return to caller
-*
-		.page
-*
-* flopwr -- Floppy write
-* ------    ------------
-flopwr:		bsr	change			* Check for disk change
-		moveq.l	#ERR10,d0		* Set write error
-		bsr	floplock		* Set parameters
-		move.w	csect(a5),d0		* Get sector number in d0
-		subq.w	#1,d0			* ... -1
-		or.w	ctrack(a5),d0		* OR with track number
-		or.w	cside(a5),d0		* OR with side number
-		bne	flopwr01		* Jump if not boot sector
-*
-		moveq.l	#2,d0			* Media change
-		bsr	setdmode		* Set to "unsure"
-*
-flopwr01:	bsr	select			* Select drive and side
-		bsr	go2track		* Seek
-		bne	flopwr06		* Re-try on error
-*
-flopwr02:	move.w	#ERR01,curerr(a5)	* Set for default error
-		move.l	cdma(a5),a2		* Get I/O address
-		move.l	#$40000,d7		* Set timeout counter
-		move.w	ctrack(a5),d0		* Get track number
-		cmpi.w	#40,d0			* See if we need precomp
-		bcs	flopwr10		* Jump if not
-*
-		move.b	#FL_WS,DSKCMD(a6)	* Write with precomp
-		bra	flopwr08		* Go join main write loop
-*
-flopwr10:	move.b	#FL_WS+FL_NC,DSKCMD(a6)	* Write  (no precomp)
-*
-		.page
-*
-flopwr08:	btst	#0,DSKCMD(a6)		* Busy yet ?
-		bne	flopwr09		* Jump if so
-*
-		subq.l	#1,d7			* Decrement tiemout count
-		bne	flopwr08		* Jump if not timed out
-*
-flopwr13:	bsr	rs1772			* Reset WD1772
-		bra	flopwr05		* See if we can retry
-*
-flopwr11:	btst	#0,DSKCMD(a6)		* Done ?
-		beq	flopwr04		* Jump if so
-*
-flopwr09:	btst	#1,DSKCMD(a6)		* DRQ set ?
-		bne	flopwr12		* Jump if so
-*
-		subq.l	#1,d7			* Decrement timeout counter
-		beq	flopwr13		* Jump if timed out
-*
-		bra	flopwr11		* Jump if not
-*
-flopwr12:	move.b	(a2)+,DSKDAT(a6)	* Write byte to floppy
-		bra	flopwr11		* Go get the next one
-*
-		.page
-*
-flopwr04:	move.b	DSKCMD(a6),d0		* Get floppy status
-		bsr	errbits			* Set error code
-		btst	#6,d0			* Write protect error ?
-		bne	flopfail		* Fail if so
-*
-		and.b	#$5C,d0			* Mask error bits
-		bne	flopwr05		* Jump if an error occurred
-*
-		addq.w	#1,csect(a5)		* Update sector number
-		add.l	#512,cdma(a5)		* Update DMA address
-		subq.w	#1,ccount(a5)		* Decrement sector count
-		beq	flopok			* Jump if zero -- done
-*
-		bsr	select1			* Set sector and DMA pointer
-		bra	flopwr02		* Write next sector
-*
-flopwr05:	cmp.w	#1,retrycnt(a5)		* Second re-try ?
-		bne	flopwr07		* Jump if not
-*
-flopwr06:	bsr	reseek			* Restore and re-seek
-*
-flopwr07:	subq.w	#1,retrycnt(a5)		* Update re-try count
-		bpl	flopwr01		* Re-try if still >0
-*
-		bra	flopfail		* ... else fail
-*
-		.page
-*
-* flopfmt -- Format a track on the floppy
-* -------    ----------------------------
-flopfmt:	cmp.l	#FMAGIC,22(a7)		* Is the magic right ?
-		bne	flopfail		* Fail immediately if not
-*
-		bsr	change			* Check for disk change
-		moveq.l	#ERR01,d0		* Set default error number
-		bsr	floplock		* Set parameters
-		bsr	select			* Select drive and side
-		move.w	14(a7),spt(a5)		* Set sectors per track,
-		move.w	20(a7),interlv(a5)	* ... interleave,
-		move.w	26(a7),virgin(a5)	* ... initial data,
-		moveq.l	#2,d0			* Disk changed
-		bsr	setdmode		* ...
-		bsr	hseek			* Seek
-		bne	flopfail		* Fail if seek error occurs
-*
-		move.w	ctrack(a5),0(a1)	* Current track to DSB
-		move.w	#ERR01,curerr(a5)	* Default to curerr
-		bsr	fmtrack			* Format the track
-		bne	flopfail		* Fail if error occurs
-*
-		move.w	spt(a5),ccount(a5)	* Use spt as ccount
-		move.w	#1,csect(a5)		* Start with sector 1
-		bsr	verify1			* Verify the sector
-		move.l	cdma(a5),a2		* Get bad sector list
-		tst.w	(a2)			* Any bad ones ?
-		beq	flopok			* Jump if not
-*
-		move.w	#ERR16,curerr(a5)	* ERROR -- "bad sectors"
+
+		bsr	restore			| Restore the drive
+		beq	flopok			| Jump if no error
+
+flopin02:	bra	flopfail		| Jump to error handler
+
+		.page
+
+| floprd -- Read floppy
+| ------    -----------
+floprd:		bsr	change			| Disk changed ?
+		moveq.l	#ERR11,d0		| Set to "read error"
+		bsr	floplock		| Set parameters
+
+floprd01:	bsr	select			| Select drive and side
+		bsr	go2track		| Position on track
+		bne	floprd02		| Try again on error
+
+		move.w	#ERR01,deferr		| Set default error
+		move.l	edma(a5),a0		| Get final DMA address
+		move.l	cdma(a5),a2		| Get first DMA address
+		move.l	#0x40000,d7		| Set timeout counter
+		move.b	#FL_RM,DSKCMD(a6)	| Start readng the disk
+
+floprd03:	btst	#0,DSKCMD(a6)		| Disk busy yet ?
+		bne	floprd05		| Jump if so
+
+		subq.l	#1,d7			| Decrement timeout counter
+		beq	floprd04		| Jump if timed out
+
+		bra	floprd03		| Go try for busy again
+
+floprd05:	move.l	#0x40000,d7		| Reset timeout counter
+		bra	floprd09		| Go join main read loop
+
+floprd07:	subq.l	#1,d7			| Decrement timeout counter
+		beq	floprd04		| Jump if timed out
+
+		btst	#0,DSKCMD(a6)		| Done yet ?
+		beq	floprd08		| Jump if so
+
+floprd09:	btst	#1,DSKCMD(a6)		| DRQ set ?
+		beq	floprd07		| Jump if not
+
+		move.b	DSKDAT(a6),(a2)+	| Read the byte into the buffer
+		cmp.l	a0,a2			| Done reading ?
+		bne	floprd07		| Jump if not
+
+		.page
+
+floprd08:	move.b	DSKCMD(a6),d0		| Read final status into d0
+		and.b	#0x1C,d0		| Mask for error bits
+		beq	flopok			| Jump if no errors
+
+		bsr	errbits			| Determine error code
+
+floprd02:	cmp.w	#1,retrycnt(a5)		| Re-try ?
+		bne	floprd06		| Jump if not
+
+		bsr	reseek			| Home and repeat the seek
+
+floprd06:	subq.w	#1,retrycnt(a5)		| Update re-try count
+		bpl	floprd01		| Re-try if count still >0
+
+		bra	flopfail		| Failure
+
+floprd04:	move.w	#ERR02,curerr(a5)	| Set error code "not ready"
+		bsr	rs1772			| Reset the WD1772
+		bra	floprd02		| See if it can be retried
+
+		.page
+
+| errbits -- Develop error code for floppy I/O error
+| -------    ---------------------------------------
+errbits:	moveq.l	#ERR13,d1		| Write protect ?
+		btst	#6,d0			| ...
+		bne	errbits1		| Jump if so
+
+		moveq.l	#ERR08,d1		| Record not found ?
+		btst	#4,d0			| ...
+		bne	errbits1		| Jump if so
+
+		moveq.l	#ERR04,d1		| CRC error ?
+		btst	#3,d0			| ...
+		bne	errbits1		| Jump if so
+
+		moveq.l	#ERR12,d1		| Lost data ?
+		btst	#2,d0			| ...
+		bne	errbits1		| Jump if so
+
+		move.w	deferr(a5),d1		| Use default error
+
+errbits1:	move.w	d1,curerr(a5)		| ... as curerr
+		rts				| Return to caller
+
+		.page
+
+| flopwr -- Floppy write
+| ------    ------------
+flopwr:		bsr	change			| Check for disk change
+		moveq.l	#ERR10,d0		| Set write error
+		bsr	floplock		| Set parameters
+		move.w	csect(a5),d0		| Get sector number in d0
+		subq.w	#1,d0			| ... -1
+		or.w	ctrack(a5),d0		| OR with track number
+		or.w	cside(a5),d0		| OR with side number
+		bne	flopwr01		| Jump if not boot sector
+
+		moveq.l	#2,d0			| Media change
+		bsr	setdmode		| Set to "unsure"
+
+flopwr01:	bsr	select			| Select drive and side
+		bsr	go2track		| Seek
+		bne	flopwr06		| Re-try on error
+
+flopwr02:	move.w	#ERR01,curerr(a5)	| Set for default error
+		move.l	cdma(a5),a2		| Get I/O address
+		move.l	#0x40000,d7		| Set timeout counter
+		move.w	ctrack(a5),d0		| Get track number
+		cmpi.w	#40,d0			| See if we need precomp
+		bcs	flopwr10		| Jump if not
+
+		move.b	#FL_WS,DSKCMD(a6)	| Write with precomp
+		bra	flopwr08		| Go join main write loop
+
+flopwr10:	move.b	#FL_WS+FL_NC,DSKCMD(a6)	| Write  (no precomp)
+
+		.page
+
+flopwr08:	btst	#0,DSKCMD(a6)		| Busy yet ?
+		bne	flopwr09		| Jump if so
+
+		subq.l	#1,d7			| Decrement tiemout count
+		bne	flopwr08		| Jump if not timed out
+
+flopwr13:	bsr	rs1772			| Reset WD1772
+		bra	flopwr05		| See if we can retry
+
+flopwr11:	btst	#0,DSKCMD(a6)		| Done ?
+		beq	flopwr04		| Jump if so
+
+flopwr09:	btst	#1,DSKCMD(a6)		| DRQ set ?
+		bne	flopwr12		| Jump if so
+
+		subq.l	#1,d7			| Decrement timeout counter
+		beq	flopwr13		| Jump if timed out
+
+		bra	flopwr11		| Jump if not
+
+flopwr12:	move.b	(a2)+,DSKDAT(a6)	| Write byte to floppy
+		bra	flopwr11		| Go get the next one
+
+		.page
+
+flopwr04:	move.b	DSKCMD(a6),d0		| Get floppy status
+		bsr	errbits			| Set error code
+		btst	#6,d0			| Write protect error ?
+		bne	flopfail		| Fail if so
+
+		and.b	#0x5C,d0		| Mask error bits
+		bne	flopwr05		| Jump if an error occurred
+
+		addq.w	#1,csect(a5)		| Update sector number
+		add.l	#512,cdma(a5)		| Update DMA address
+		subq.w	#1,ccount(a5)		| Decrement sector count
+		beq	flopok			| Jump if zero -- done
+
+		bsr	select1			| Set sector and DMA pointer
+		bra	flopwr02		| Write next sector
+
+flopwr05:	cmp.w	#1,retrycnt(a5)		| Second re-try ?
+		bne	flopwr07		| Jump if not
+
+flopwr06:	bsr	reseek			| Restore and re-seek
+
+flopwr07:	subq.w	#1,retrycnt(a5)		| Update re-try count
+		bpl	flopwr01		| Re-try if still >0
+
+		bra	flopfail		| ... else fail
+
+		.page
+
+| flopfmt -- Format a track on the floppy
+| -------    ----------------------------
+flopfmt:	cmp.l	#FMAGIC,22(a7)		| Is the magic right ?
+		bne	flopfail		| Fail immediately if not
+
+		bsr	change			| Check for disk change
+		moveq.l	#ERR01,d0		| Set default error number
+		bsr	floplock		| Set parameters
+		bsr	select			| Select drive and side
+		move.w	14(a7),spt(a5)		| Set sectors per track,
+		move.w	20(a7),interlv(a5)	| ... interleave,
+		move.w	26(a7),virgin(a5)	| ... initial data,
+		moveq.l	#2,d0			| Disk changed
+		bsr	setdmode		| ...
+		bsr	hseek			| Seek
+		bne	flopfail		| Fail if seek error occurs
+
+		move.w	ctrack(a5),0(a1)	| Current track to DSB
+		move.w	#ERR01,curerr(a5)	| Default to curerr
+		bsr	fmtrack			| Format the track
+		bne	flopfail		| Fail if error occurs
+
+		move.w	spt(a5),ccount(a5)	| Use spt as ccount
+		move.w	#1,csect(a5)		| Start with sector 1
+		bsr	verify1			| Verify the sector
+		move.l	cdma(a5),a2		| Get bad sector list
+		tst.w	(a2)			| Any bad ones ?
+		beq	flopok			| Jump if not
+
+		move.w	#ERR16,curerr(a5)	| ERROR -- "bad sectors"
 		bra	flopfail
-*
-		.page
-*
-* fmtrack -- Do the dirty work of formatting a track
-* -------    ---------------------------------------
-fmtrack:	move.w	#ERR10,deferr(a5)	* Set default error number
-		move.w	#1,d3			* Start with sector 1
-		move.l	cdma(a5),a2		* Get track buffer address
-		move.w	#60-1,d1		* Set count = 60
-		move.b	#$4E,d0			* Write $4E as initial gap
-		bsr	wmult			* ...
-*
-fmtrak01:	move.w	d3,d4			* Save sector number in d4
-*
-fmtrak02:	move.w	#12-1,d1		* Set count = 12
-		clr.b	d0			* Write $00 as sync
-		bsr	wmult			* ...
-		move.w	#3-1,d1			* Set count = 3
-		move.b	#$F5,d0			* Write $F5's
-		bsr	wmult			* ...
-		move.b	#$FE,(a2)+		* Write $FE (address mark)
-		move.b	ctrack+1,(a2)+		* Write track #
-		move.b	cside+1,(a2)+		* Write side #
-		move.b	d4,(a2)+		* Write sector #
-		move.b	#2,(a2)+		* Write sector size code
-		move.b	#$F7,(a2)+		* Write checksum code
-		move.w	#22-1,d1		* Set count = 22
-		move.b	#$4E,d0			* Write gap
-		bsr	wmult			* ...
-		move.w	#12-1,d1		* Set count = 12
-		clr.b	d0			* Write $00 as sync
-		bsr	wmult			* ...
-		move.w	#3-1,d1			* Set count = 3
-		move.b	#$F5,d0			* Write $F5's
-		bsr	wmult			* ...
-		move.b	#$FB,(a2)+		* Write DAM
-		move.w	#256-1,d1		* Set count = 256 words
-*
-		.page
-*
-fmtrak03:	move.b	virgin(a5),(a2)+	* Write virgin data in buffer
-		move.b	virgin+1(a5),(a2)+	* ...
-		dbf	d1,fmtrak03		* ...
-*
-		move.b	#$F7,(a2)+		* Write CRC code
-		move.w	#40-1,d1		* Set count = 40
-		move.b	#$4E,d0			* Write gap
-		bsr	wmult			* ...
-		add.w	interlv(a5),d4		* Add interleave to sector #
-		cmp.w	spt(a5),d4		* Check against spt
-		ble	fmtrak02		* Jump if not >
-*
-		addq.w	#1,d3			* Starting sector +1
+
+		.page
+
+| fmtrack -- Do the dirty work of formatting a track
+| -------    ---------------------------------------
+fmtrack:	move.w	#ERR10,deferr(a5)	| Set default error number
+		move.w	#1,d3			| Start with sector 1
+		move.l	cdma(a5),a2		| Get track buffer address
+		move.w	#60-1,d1		| Set count = 60
+		move.b	#0x4E,d0		| Write 0x4E as initial gap
+		bsr	wmult			| ...
+
+fmtrak01:	move.w	d3,d4			| Save sector number in d4
+
+fmtrak02:	move.w	#12-1,d1		| Set count = 12
+		clr.b	d0			| Write 0x00 as sync
+		bsr	wmult			| ...
+		move.w	#3-1,d1			| Set count = 3
+		move.b	#0xF5,d0		| Write 0xF5's
+		bsr	wmult			| ...
+		move.b	#0xFE,(a2)+		| Write 0xFE (address mark)
+		move.b	ctrack+1,(a2)+		| Write track #
+		move.b	cside+1,(a2)+		| Write side #
+		move.b	d4,(a2)+		| Write sector #
+		move.b	#2,(a2)+		| Write sector size code
+		move.b	#0xF7,(a2)+		| Write checksum code
+		move.w	#22-1,d1		| Set count = 22
+		move.b	#0x4E,d0		| Write gap
+		bsr	wmult			| ...
+		move.w	#12-1,d1		| Set count = 12
+		clr.b	d0			| Write 0x00 as sync
+		bsr	wmult			| ...
+		move.w	#3-1,d1			| Set count = 3
+		move.b	#0xF5,d0		| Write 0xF5's
+		bsr	wmult			| ...
+		move.b	#0xFB,(a2)+		| Write DAM
+		move.w	#256-1,d1		| Set count = 256 words
+
+		.page
+
+fmtrak03:	move.b	virgin(a5),(a2)+	| Write virgin data in buffer
+		move.b	virgin+1(a5),(a2)+	| ...
+		dbf	d1,fmtrak03		| ...
+
+		move.b	#0xF7,(a2)+		| Write CRC code
+		move.w	#40-1,d1		| Set count = 40
+		move.b	#0x4E,d0		| Write gap
+		bsr	wmult			| ...
+		add.w	interlv(a5),d4		| Add interleave to sector #
+		cmp.w	spt(a5),d4		| Check against spt
+		ble	fmtrak02		| Jump if not >
+
+		addq.w	#1,d3			| Starting sector +1
 		cmp.w	interlv(a5),d3
 		ble	fmtrak01
-*
-		move.w	#1401-1,d1		* Set count = 1401
-		move.b	#$4E,d0			* Write final gap
-		bsr	wmult			* ...
-		move.l	cdma(a5),a2		* Get buffer address
-		move.l	#$40000,d7		* Set timeout count
-		move.w	ctrack(a5),d0		* Get track number
-		cmpi.w	#40,d0			* Do we need precomp ?
-		bcs	fmtrak08		* Jump if not
-*
-		move.b	#FL_WT,DSKCMD(a6)	* Start format with precomp
-		bra	fmtrak07		* Go join main format loop
-*
-fmtrak08:	move.b	#FL_WT+FL_NC,DSKCMD(a6)	* Start format without precomp
-*
-		.page
-*
-fmtrak07:	btst	#0,DSKCMD(a6)		* Busy yet ?
-		bne	fmtrak09		* Jump if so
-*
-fmtrak04:	subq.l	#1,d7			* Decrement timeout counter
-		bne	fmtrak07		* Jump if not timed out
-*
-fmtrak05:	bsr	rs1772			* Reset WD1772
-		moveq.l	#1,d7			* Set error flag
-		rts				* Return to caller
-*
-fmtrak11:	btst	#0,DSKCMD(a6)		* Done ?
-		beq	fmtrak06		* Jump if so
-*
-fmtrak09:	btst	#1,DSKCMD(a6)		* DRQ set ?
-		bne	fmtrak10		* Jump if so
-*
-		subq.l	#1,d7			* Decrement timeout coutner
-		beq	fmtrak05		* Jump if timed out
-*
-		bra	fmtrak11		* Go check again
-*
-fmtrak10:	move.b	(a2)+,DSKDAT(a6)	* Write a byte of format
-		bra	fmtrak11		* Go wait for DRQ
-*
-fmtrak06:	move.b	DSKCMD(a6),d0		* Get final status
-		bsr	errbits			* Set possible error code
-		andi.b	#$44,d0			* Check error bits
-		rts				* Return to caller with status
-*
-* wmult -- write multiple bytes into the track buffer
-* -----    ------------------------------------------
-wmult:		move.b	d0,(a2)+		* Move a byte into the buffer
-		dbf	d1,wmult		* Loop until we're done
-*
-		rts				* Return to caller
-*
-		.page
-*
-* flopver -- verify sector(s) on a floppy
-* -------    ----------------------------
-flopver:	bsr	change			* Check for disk change
-		moveq.l	#ERR11,d0		* Set default to "read error"
-		bsr	floplock		* Set parameters
-		bsr	select			* Select drive and side
-		bsr	go2track		* Seek
-		bne	flopfail		* Jump if seek error
-*
-		bsr	verify1			* Verify the data
-		bra	flopok			* Done
-*
-* verify1 -- Verify the data for a sector
-* -------    ----------------------------
-verify1:	move.w	#ERR11,deferr(a5)	* Set default = "read error"
-		move.l	cdma(a5),a2		* Pointer for bad sector list
-		add.l	#512,cdma(a5)		* Update by length of a sector
-*
-verify01:	move.w	#2,retrycnt(a5)		* Set retrycnt for 2 attempts
-		move.w	csect(a5),d7		* Get sector nubmer
-		move.b	d7,DSKSEC(a6)		* Send to WD1772
-*
-verify02:	moveq.l	#0,d6			* Clear bad compare flag
-		move.l	cdma(a5),a0		* Get compare address
-		move.l	#$40000,d7		* Set timeout counter
-		move.b	#FL_RS,DSKCMD(a6)	* Start the read
-*
-verify08:	btst	#0,DSKCMD(a6)		* Busy yet ?
-		bne	verify09		* Jump if so
-*
-		subq.l	#1,d7			* Decrement timeout counter
-		beq	verify13		* Jump if timed out
-*
-		bra	verify08		* Wait for busy some more
-*
-verify09:	move.l	#$40000,d7		* Reset timeout counter
-		bra	verify11		* Go join main compare loop
-*
-verify10:	subq.l	#1,d7			* Decrement timeout counter
-		beq	verify13		* Jump if timed out
-*
-		btst	#0,DSKCMD(a6)		* Done yet ?
-		beq	verify12		* Jump if so
-*
-		.page
-*
-verify11:	btst	#1,DSKCMD(a6)		* DRQ set ?
-		beq	verify10		* Jump if not
-*
-		move.b	DSKDAT(a6),d0		* Read data
-		bra	verify10		* Continue reading
-*
-verify12:	move.b	DSKCMD(a6),d0		* Get final status
-		bsr	errbits			* Determine error code
-		and.b	#$1C,d0			* Mask RNF, CRC, LOST
-		bne	verify06		* Jump to re-try if any set
-*
-verify05:	addq.w	#1,csect(a5)		* Update sector number
-		subq.w	#1,ccount(a5)		* Update sector count
-		bne	verify01		* Jump if more to do
-*
-		sub.l	#512,cdma(a5)		* Reset DMA pointer
-		clr.w	(a2)			* Set NIL in bad sector list
-		rts				* Return to caller
-*
-verify06:	cmp.w	#1,retrycnt(a5)		* Is it the 2nd attempt ?
-		bne	verify07		* Jump if not
-*
-		bsr	reseek			* Restore and re-seek
-*
-verify07:	subq.w	#1,retrycnt(a5)		* Decrement retry count
-		bpl	verify02		* Re-try if still positive
-*
-		move.w	csect(a5),(a2)+		* Add to bad sector list
-		bra	verify05		* Go do next sector
-*
-verify13:	move.w	#ERR02,curerr(a5)	* Set timeout error code
-		bsr	rs1772			* Reset WD1772
-		bra	verify06		* See if we can retry it
-*
-		.page
-*
-* flopvbl -- Floppy VBL timer interrupt handling
-* -------    -----------------------------------
-flopvbl:	movem.l	d0-d1/a0-a1/a5-a6,-(a7)	* Save registers
-		sub.l	a5,a5			* Clear a5 for use as RAM base
-		lea	FLOPPY,a6		* Base of floppy regs
-		st	motoron(a5)		* Set motoron flag
-		move.l	frclock(a5),d0		* Get interrupt count
-		move.b	d0,d1			* ...
-		and.b	#7,d1			* ... MOD 8
-		bne	flopvb02		* Jump if not 8th int
-*
-		move.w	sr,-(a7)		* Save interrupt level
-		ori.w	#IPL7,sr		* Mask off interrupts
-		clr.w	deslflag(a5)		* Clear deselect flag
-		move.b	mc1iorec+cfr1,d0	* Get port status
-		ori.b	#1,d0			* Set drive select bit
-		move.b	d0,MC1ACIA+ACIA_CFR	* Send drive select to port
-		move.b	d0,mc1iorec+cfr1	* Store updated port status
-		move.w	(a7)+,sr		* Restore interrupt level
-		lea	wpstatus(a5),a0		* Point at wpstatus for drive
-		lea	dsb0(a5),a1		* Point at dsb0
-		move.b	DSKCMD(a6),d0		* Read WD1772 status
-		btst	#6,d0			* Test write protect bit
-		sne	(a0)			* ... and save
-*
-		.page
-*
-flopvb02:	move.w	wpstatus(a5),d0		* Get wpstatus of drive A
-		or.w	d0,wplatch(a5)		* OR into wplatch
-		tst.w	deslflag(a5)		* Floppies already deselected ?
-		bne	flopvb03		* Jump if so
-*
-		move.b	DSKCMD(a6),d0		* Read WD1772 status
-		btst	#7,d0			* Motor-on bit set ?
-		bne	flopvb04		* Don't de-select if it is
-*
-		move.w	sr,-(a7)		* Save sr
-		ori.w	#IPL7,sr		* Disable interrupts
-		move.b	mc1iorec+cfr1,d0	* Get cfr1 image
-		bclr	#0,d0			* Clear d0  (drive select)
-		move.b	d0,mc1iorec+cfr1	* Save new value
-		move.b	d0,MC1ACIA+ACIA_CFR	* Send to hardware
-		move.w	(a7)+,sr		* Restore sr  (enable ints)
-		move.w	#1,deslflag(a5)		* Set the deselect flag
-*
-flopvb03:	clr.w	motoron(a5)		* Clear motoron flag
-*
-flopvb04:	movem.l	(a7)+,d0-d1/a0-a1/a5-a6	* Restore registers
-		rts				* Return to caller
-*
-		.page
-*
-* floplock -- Setup floppy parameters
-* --------    -----------------------
-floplock:	movem.l	d3-d7/a3-a6,flpregs	* Save registers
-		move.w	sr,flpsrsv		* Save sr
-		ori.w	#IPL7,sr		* Disable ints
-		sub.l	a5,a5			* Clear a5
-		lea	FLOPPY,a6		* Base of floppy registers
-		st	motoron(a5)		* Set motoron flag
-		move.w	d0,deferr(a5)		* Set default error code
-		move.w	d0,curerr(a5)		* ... current error code
-		move.w	#1,flock(a5)		* Disable flopvbl routine
-		move.l	8(a7),cdma(a5)		* Set cdma
-		move.w	16(a7),cdev(a5)		* ... cdev
-		move.w	18(a7),csect(a5)	* ... csect
-		move.w	20(a7),ctrack(a5)	* ... ctrack
-		move.w	22(a7),cside(a5)	* ... cside
-		move.w	24(a7),ccount(a5)	* ... ccount
-		move.w	#2,retrycnt(a5)		* ... retrycnt
-		lea	dsb0(a5),a1		* Address of dsb0
-		tst.w	cdev(a5)		* Drive A ?
-		beq	floplk01		* Jump if so
-*
-		lea	dsb1(a5),a1		* Drive B, use dsb1
-*
-floplk01:	moveq.l	#0,d7			* Clear out d7
-		move.w	ccount(a5),d7		* Get ccount
-		lsl.w	#8,d7			* ... * sector length  (512)
-		lsl.w	#1,d7			* ...
-		move.l	cdma(a5),a0		* Get DMA start address
-		add.l	d7,a0			* Add length of sectors
-		move.l	a0,edma(a5)		* Set edma  (end DMA address)
-		tst.w	0(a1)			* Check current track
-		bpl	floplk03		* Jump if >= 0
-*
-		bsr	select			* Select the drive
-		clr.w	0(a1)			* Set current track to 0
-		bsr	restore			* Restore drive to track 0
-		beq	floplk03		* Jump if OK
-*
-		moveq.l	#10,d7			* Seek out to track 10
-		bsr	hseek1			* ...
-		bne	floplk02		* Jump if an error occurred
-*
-		bsr	restore			* Try the restore again
-		beq	floplk03		* Jump if OK
-*
-floplk02:	move.w	#$FF00,0(a1)		* Recalibrate error
-*
-floplk03:	rts				* Return to caller
-*
-		.page
-*
-* flopfail -- Floppy I/O failure exit
-* --------    -----------------------
-flopfail:	moveq.l	#1,d0			* Set media change to "unsure"
-		bsr	setdmode		* ...
-		move.w	curerr(a5),d0		* Get curerr
-		ext.l	d0			* ...
-		bra	flopok1			* Go set end status
-*
-* flopok -- Floppy I/O success exit
-* ------    -----------------------
-flopok:		clr.l	d0			* Set error code = 0  (no error)
-*
-flopok1:	move.l	d0,-(a7)		* Push code onto stack
-		move.w	0(a1),d7		* Get track number
-		move.b	d7,DSKDAT(a6)		* Send to WD1772
-		move.w	#FL_SK,d6		* Seek command to d6
-		bsr	flopcmds		* Send command
-		move.w	cdev(a5),d0		* Get drive number
-		lsl.w	#2,d0			* Use as index
-		lea	acctim(a5),a0		* ... into acctim
-		move.l	_hz_200(a5),0(a0,d0)	* Set last access time
+
+		move.w	#1401-1,d1		| Set count = 1401
+		move.b	#0x4E,d0		| Write final gap
+		bsr	wmult			| ...
+		move.l	cdma(a5),a2		| Get buffer address
+		move.l	#0x40000,d7		| Set timeout count
+		move.w	ctrack(a5),d0		| Get track number
+		cmpi.w	#40,d0			| Do we need precomp ?
+		bcs	fmtrak08		| Jump if not
+
+		move.b	#FL_WT,DSKCMD(a6)	| Start format with precomp
+		bra	fmtrak07		| Go join main format loop
+
+fmtrak08:	move.b	#FL_WT+FL_NC,DSKCMD(a6)	| Start format without precomp
+
+		.page
+
+fmtrak07:	btst	#0,DSKCMD(a6)		| Busy yet ?
+		bne	fmtrak09		| Jump if so
+
+fmtrak04:	subq.l	#1,d7			| Decrement timeout counter
+		bne	fmtrak07		| Jump if not timed out
+
+fmtrak05:	bsr	rs1772			| Reset WD1772
+		moveq.l	#1,d7			| Set error flag
+		rts				| Return to caller
+
+fmtrak11:	btst	#0,DSKCMD(a6)		| Done ?
+		beq	fmtrak06		| Jump if so
+
+fmtrak09:	btst	#1,DSKCMD(a6)		| DRQ set ?
+		bne	fmtrak10		| Jump if so
+
+		subq.l	#1,d7			| Decrement timeout coutner
+		beq	fmtrak05		| Jump if timed out
+
+		bra	fmtrak11		| Go check again
+
+fmtrak10:	move.b	(a2)+,DSKDAT(a6)	| Write a byte of format
+		bra	fmtrak11		| Go wait for DRQ
+
+fmtrak06:	move.b	DSKCMD(a6),d0		| Get final status
+		bsr	errbits			| Set possible error code
+		andi.b	#0x44,d0		| Check error bits
+		rts				| Return to caller with status
+
+| wmult -- write multiple bytes into the track buffer
+| -----    ------------------------------------------
+wmult:		move.b	d0,(a2)+		| Move a byte into the buffer
+		dbf	d1,wmult		| Loop until we're done
+
+		rts				| Return to caller
+
+		.page
+
+| flopver -- verify sector(s) on a floppy
+| -------    ----------------------------
+flopver:	bsr	change			| Check for disk change
+		moveq.l	#ERR11,d0		| Set default to "read error"
+		bsr	floplock		| Set parameters
+		bsr	select			| Select drive and side
+		bsr	go2track		| Seek
+		bne	flopfail		| Jump if seek error
+
+		bsr	verify1			| Verify the data
+		bra	flopok			| Done
+
+| verify1 -- Verify the data for a sector
+| -------    ----------------------------
+verify1:	move.w	#ERR11,deferr(a5)	| Set default = "read error"
+		move.l	cdma(a5),a2		| Pointer for bad sector list
+		add.l	#512,cdma(a5)		| Update by length of a sector
+
+verify01:	move.w	#2,retrycnt(a5)		| Set retrycnt for 2 attempts
+		move.w	csect(a5),d7		| Get sector nubmer
+		move.b	d7,DSKSEC(a6)		| Send to WD1772
+
+verify02:	moveq.l	#0,d6			| Clear bad compare flag
+		move.l	cdma(a5),a0		| Get compare address
+		move.l	#0x40000,d7		| Set timeout counter
+		move.b	#FL_RS,DSKCMD(a6)	| Start the read
+
+verify08:	btst	#0,DSKCMD(a6)		| Busy yet ?
+		bne	verify09		| Jump if so
+
+		subq.l	#1,d7			| Decrement timeout counter
+		beq	verify13		| Jump if timed out
+
+		bra	verify08		| Wait for busy some more
+
+verify09:	move.l	#0x40000,d7		| Reset timeout counter
+		bra	verify11		| Go join main compare loop
+
+verify10:	subq.l	#1,d7			| Decrement timeout counter
+		beq	verify13		| Jump if timed out
+
+		btst	#0,DSKCMD(a6)		| Done yet ?
+		beq	verify12		| Jump if so
+
+		.page
+
+verify11:	btst	#1,DSKCMD(a6)		| DRQ set ?
+		beq	verify10		| Jump if not
+
+		move.b	DSKDAT(a6),d0		| Read data
+		bra	verify10		| Continue reading
+
+verify12:	move.b	DSKCMD(a6),d0		| Get final status
+		bsr	errbits			| Determine error code
+		and.b	#0x1C,d0		| Mask RNF, CRC, LOST
+		bne	verify06		| Jump to re-try if any set
+
+verify05:	addq.w	#1,csect(a5)		| Update sector number
+		subq.w	#1,ccount(a5)		| Update sector count
+		bne	verify01		| Jump if more to do
+
+		sub.l	#512,cdma(a5)		| Reset DMA pointer
+		clr.w	(a2)			| Set NIL in bad sector list
+		rts				| Return to caller
+
+verify06:	cmp.w	#1,retrycnt(a5)		| Is it the 2nd attempt ?
+		bne	verify07		| Jump if not
+
+		bsr	reseek			| Restore and re-seek
+
+verify07:	subq.w	#1,retrycnt(a5)		| Decrement retry count
+		bpl	verify02		| Re-try if still positive
+
+		move.w	csect(a5),(a2)+		| Add to bad sector list
+		bra	verify05		| Go do next sector
+
+verify13:	move.w	#ERR02,curerr(a5)	| Set timeout error code
+		bsr	rs1772			| Reset WD1772
+		bra	verify06		| See if we can retry it
+
+		.page
+
+| flopvbl -- Floppy VBL timer interrupt handling
+| -------    -----------------------------------
+flopvbl:	movem.l	d0-d1/a0-a1/a5-a6,-(a7)	| Save registers
+		sub.l	a5,a5			| Clear a5 for use as RAM base
+		lea	FLOPPY,a6		| Base of floppy regs
+		st	motoron(a5)		| Set motoron flag
+		move.l	frclock(a5),d0		| Get interrupt count
+		move.b	d0,d1			| ...
+		and.b	#7,d1			| ... MOD 8
+		bne	flopvb02		| Jump if not 8th int
+
+		move.w	sr,-(a7)		| Save interrupt level
+		ori.w	#IPL7,sr		| Mask off interrupts
+		clr.w	deslflag(a5)		| Clear deselect flag
+		move.b	mc1iorec+cfr1,d0	| Get port status
+		ori.b	#1,d0			| Set drive select bit
+		move.b	d0,MC1ACIA+ACIA_CFR	| Send drive select to port
+		move.b	d0,mc1iorec+cfr1	| Store updated port status
+		move.w	(a7)+,sr		| Restore interrupt level
+		lea	wpstatus(a5),a0		| Point at wpstatus for drive
+		lea	dsb0(a5),a1		| Point at dsb0
+		move.b	DSKCMD(a6),d0		| Read WD1772 status
+		btst	#6,d0			| Test write protect bit
+		sne	(a0)			| ... and save
+
+		.page
+
+flopvb02:	move.w	wpstatus(a5),d0		| Get wpstatus of drive A
+		or.w	d0,wplatch(a5)		| OR into wplatch
+		tst.w	deslflag(a5)		| Floppies already deselected ?
+		bne	flopvb03		| Jump if so
+
+		move.b	DSKCMD(a6),d0		| Read WD1772 status
+		btst	#7,d0			| Motor-on bit set ?
+		bne	flopvb04		| Don't de-select if it is
+
+		move.w	sr,-(a7)		| Save sr
+		ori.w	#IPL7,sr		| Disable interrupts
+		move.b	mc1iorec+cfr1,d0	| Get cfr1 image
+		bclr	#0,d0			| Clear d0  (drive select)
+		move.b	d0,mc1iorec+cfr1	| Save new value
+		move.b	d0,MC1ACIA+ACIA_CFR	| Send to hardware
+		move.w	(a7)+,sr		| Restore sr  (enable ints)
+		move.w	#1,deslflag(a5)		| Set the deselect flag
+
+flopvb03:	clr.w	motoron(a5)		| Clear motoron flag
+
+flopvb04:	movem.l	(a7)+,d0-d1/a0-a1/a5-a6	| Restore registers
+		rts				| Return to caller
+
+		.page
+
+| floplock -- Setup floppy parameters
+| --------    -----------------------
+floplock:	movem.l	d3-d7/a3-a6,flpregs	| Save registers
+		move.w	sr,flpsrsv		| Save sr
+		ori.w	#IPL7,sr		| Disable ints
+		sub.l	a5,a5			| Clear a5
+		lea	FLOPPY,a6		| Base of floppy registers
+		st	motoron(a5)		| Set motoron flag
+		move.w	d0,deferr(a5)		| Set default error code
+		move.w	d0,curerr(a5)		| ... current error code
+		move.w	#1,flock(a5)		| Disable flopvbl routine
+		move.l	8(a7),cdma(a5)		| Set cdma
+		move.w	16(a7),cdev(a5)		| ... cdev
+		move.w	18(a7),csect(a5)	| ... csect
+		move.w	20(a7),ctrack(a5)	| ... ctrack
+		move.w	22(a7),cside(a5)	| ... cside
+		move.w	24(a7),ccount(a5)	| ... ccount
+		move.w	#2,retrycnt(a5)		| ... retrycnt
+		lea	dsb0(a5),a1		| Address of dsb0
+		tst.w	cdev(a5)		| Drive A ?
+		beq	floplk01		| Jump if so
+
+		lea	dsb1(a5),a1		| Drive B, use dsb1
+
+floplk01:	moveq.l	#0,d7			| Clear out d7
+		move.w	ccount(a5),d7		| Get ccount
+		lsl.w	#8,d7			| ... | sector length  (512)
+		lsl.w	#1,d7			| ...
+		move.l	cdma(a5),a0		| Get DMA start address
+		add.l	d7,a0			| Add length of sectors
+		move.l	a0,edma(a5)		| Set edma  (end DMA address)
+		tst.w	0(a1)			| Check current track
+		bpl	floplk03		| Jump if >= 0
+
+		bsr	select			| Select the drive
+		clr.w	0(a1)			| Set current track to 0
+		bsr	restore			| Restore drive to track 0
+		beq	floplk03		| Jump if OK
+
+		moveq.l	#10,d7			| Seek out to track 10
+		bsr	hseek1			| ...
+		bne	floplk02		| Jump if an error occurred
+
+		bsr	restore			| Try the restore again
+		beq	floplk03		| Jump if OK
+
+floplk02:	move.w	#0xFF00,0(a1)		| Recalibrate error
+
+floplk03:	rts				| Return to caller
+
+		.page
+
+| flopfail -- Floppy I/O failure exit
+| --------    -----------------------
+flopfail:	moveq.l	#1,d0			| Set media change to "unsure"
+		bsr	setdmode		| ...
+		move.w	curerr(a5),d0		| Get curerr
+		ext.l	d0			| ...
+		bra	flopok1			| Go set end status
+
+| flopok -- Floppy I/O success exit
+| ------    -----------------------
+flopok:		clr.l	d0			| Set error code = 0  (no error)
+
+flopok1:	move.l	d0,-(a7)		| Push code onto stack
+		move.w	0(a1),d7		| Get track number
+		move.b	d7,DSKDAT(a6)		| Send to WD1772
+		move.w	#FL_SK,d6		| Seek command to d6
+		bsr	flopcmds		| Send command
+		move.w	cdev(a5),d0		| Get drive number
+		lsl.w	#2,d0			| Use as index
+		lea	acctim(a5),a0		| ... into acctim
+		move.l	_hz_200(a5),0(a0,d0)	| Set last access time
 		cmp.w	#1,nflops(a5)
 		bne	flopok01
-*
-		move.l	_hz_200(a5),4(a0)	* Time for other drive
-*
-flopok01:	move.w	flpsrsv,sr		* Restore sr  (enable ints)
-		move.l	(a7)+,d0		* Restore error number to d0
-		movem.l	flpregs,d3-d7/a3-a6	* Restore registers
-		clr.w	flock			* Release flopvbl routine
-		rts				* Return to caller
-*
-		.page
-*
-* hseek -- seek to track in ctrack
-* -----    -----------------------
-hseek:		move.w	ctrack,d7		* Get ctrack
-*
-* hseek1 -- seek to track in d7
-* ------    -------------------
-hseek1:		move.w	#ERR10,curerr		* Set curerr = "seek error"
-		move.b	d7,DSKDAT(a6)		* Send track number to WD1772
-		move.w	#FL_SK,d6		* Seek command
-		bra	flopcmds		* Go send command to WD1772
-*
-* reseek -- Restore, then re-seek
-* ------    ---------------------
-reseek:		move.w	#ERR10,curerr		* Set curerr = "seek error"
-		bsr	restore			* Restore
-		bne	reseek01		* Jump if error occurred
-*
-		clr.w	0(a1)			* Clear current track to 0
-		move.b	#0,DSKTRK(a6)		* Send track to WD1772
-		move.b	#5,DSKDAT(a6)		* Setup to seek to track 5
-		move.w	#FL_SK,d6		* Seek command
-		bsr	flopcmds		* Seek
-		bne	reseek01		* Jump if error
-*
-		move.w	#5,0(a1)		* Update current track = 5
-*
-* go2track -- seek with verify
-* --------    ----------------
-go2track:	move.w	#ERR10,curerr(a5)	* Set curerr = "seek error"
-		move.w	ctrack(a5),d7		* Put track # in d7
-		move.b	d7,DSKDAT(a6)		* Send track to WD1772
-		moveq.l	#FL_SV,d6		* Seek/verify command
-		bsr	flopcmds		* Send command to floppy
-		bne	reseek01		* Jump if error occurred
-*
-		move.w	ctrack(a5),0(a1)	* Update track number in dsb
-		and.b	#$18,d7			* Test for RNF, CRC, LOST
-*
-reseek01:	rts				* Return to caller
-*
-		.page
-*
-* restore -- Restore to track 0
-* -------    ------------------
-restore:	clr.w	d6			* Restore command
-		bsr	flopcmds		* Send to WD1772
-		bne	restor01		* Jump if an error occurred
-*
-		btst	#2,d7			* Check track 0 bit
-		eori	#0004,sr		* Invert Z flag in 680000 sr
-		bne	restor01		* Jump if not track 0
-*
-		clr.w	0(a1)			* Set track = 0 in dsb
-*
-restor01:	rts				* Return to caller
-*
-* flopcmds -- Send command to WD1772 floppy controller
-* --------    ----------------------------------------
-flopcmds:	move.w	2(a1),d0		* Get seek rate from dsb
-		and.b	#$3,d0			* ...
-		or.b	d0,d6			* OR into command word
-		move.l	#$40000,d7		* Set timeout counter
-		btst	#7,DSKCMD(a6)		* Motor on ?
-		bne	flopcm01		* Jump if so
-*
-		move.l	#$60000,d7		* Set longer timeout count
-*
-flopcm01:	move.b	d6,DSKCMD(a6)		* Write command from d6
-*
-		move.l	#$1000,d0		* Set initial busy timeout in d0
-*
-flopcm04:	btst	#0,DSKCMD(a6)		* Controller busy yet ?
-		bne	flopcm02		* Jump if so
-*
-		subq.l	#1,d0			* Decrement timeout counter
-		beq	flopcm03		* Jump if timed out
-*
-		bra	flopcm04		* Wait for busy some more
-*
-flopcm02:	subq.l	#1,d7			* Decrement timeout counter
-		beq	flopcm03		* Jump if timed out
-*
-		btst	#0,DSKCMD(a6)		* WD1772 done ?
-		bne	flopcm02		* Jump if not
-*
-		clr.l	d7			* Clear out upper bits of d7
-		move.b	DSKCMD(a6),d7		* Read status into LS byte of d7
-		clr.l	d6			* Clear error flag in d6
-		rts				* Return to caller
-*
-flopcm03:	bsr	rs1772			* Reset WD1772  (end transfer)
-		moveq.l	#1,d6			* Set error flag in d6
-		rts				* Return to caller
-*
-		.page
-*
-* rs1772 -- Reset WD1772 floppy controller
-* ------    ------------------------------
-rs1772:		move.b	#FL_FR,DSKCMD(a6)	* Send reset to WD1772
-		move.w	#15,d7			* Set delay count
-*
-rs1772a:	dbf	d7,rs1772a		* Delay a while
-		rts				* Return to caller
-*
-* select -- Select drive and side
-* ------    ----------------------
-select:		move.w	sr,-(a7)		* Save sr on stack
-		ori.w	#IPL7,sr		* Disable interrupts
-		clr.w	deslflag(a5)		* Clear deselect flag
-		move.b	mc1iorec+cfr1,d0	* Get current MC1 cfr1 image
-		ori.b	#1,d0			* Select drive  (we only have 1)
-		move.b	d0,mc1iorec+cfr1	* Store updated image
-		move.b	d0,MC1ACIA+ACIA_CFR	* Send it to the MC1 ACIA
-		move.w	cside(a5),d0		* Get side number  (LS bit)
-		and.w	#1,d0			* Mask off garbage bits
-		andi.b	#$FE,mc2iorec+cfr1	* Mask off D0 in MC2 cfr1 image
-		or.b	mc2iorec+cfr1,d0	* OR side with mc2iorec cfr1
-		move.b	d0,mc2iorec+cfr1	* Store updated cfr1 image
-		move.b	d0,MC2ACIA+ACIA_CFR	* Send it to the MC2 ACIA
-		move.w	(a7)+,sr		* Restore interrupts
-		move.w	0(a1),d7		* Get track from dsb
-		move.b	d7,DSKTRK(a6)		* Send it to the WD1772
-		clr.b	tmpdma(a5)		* Clear bits 31..24 of tmpdma
-*
-select1:	move.w	csect(a5),d7		* Get sector number
-		move.b	d7,DSKSEC(a6)		* Send it to the WD1772
-		move.l	cdma(a5),a0		* Setup transfer address in a0
-		rts				* Return to caller
-*
-		.page
-*
-* change -- Check for disk change status
-* ------    ----------------------------
-change:		cmp.w	#1,nflops		* Check # of floppies
+
+		move.l	_hz_200(a5),4(a0)	| Time for other drive
+
+flopok01:	move.w	flpsrsv,sr		| Restore sr  (enable ints)
+		move.l	(a7)+,d0		| Restore error number to d0
+		movem.l	flpregs,d3-d7/a3-a6	| Restore registers
+		clr.w	flock			| Release flopvbl routine
+		rts				| Return to caller
+
+		.page
+
+| hseek -- seek to track in ctrack
+| -----    -----------------------
+hseek:		move.w	ctrack,d7		| Get ctrack
+
+| hseek1 -- seek to track in d7
+| ------    -------------------
+hseek1:		move.w	#ERR10,curerr		| Set curerr = "seek error"
+		move.b	d7,DSKDAT(a6)		| Send track number to WD1772
+		move.w	#FL_SK,d6		| Seek command
+		bra	flopcmds		| Go send command to WD1772
+
+| reseek -- Restore, then re-seek
+| ------    ---------------------
+reseek:		move.w	#ERR10,curerr		| Set curerr = "seek error"
+		bsr	restore			| Restore
+		bne	reseek01		| Jump if error occurred
+
+		clr.w	0(a1)			| Clear current track to 0
+		move.b	#0,DSKTRK(a6)		| Send track to WD1772
+		move.b	#5,DSKDAT(a6)		| Setup to seek to track 5
+		move.w	#FL_SK,d6		| Seek command
+		bsr	flopcmds		| Seek
+		bne	reseek01		| Jump if error
+
+		move.w	#5,0(a1)		| Update current track = 5
+
+| go2track -- seek with verify
+| --------    ----------------
+go2track:	move.w	#ERR10,curerr(a5)	| Set curerr = "seek error"
+		move.w	ctrack(a5),d7		| Put track # in d7
+		move.b	d7,DSKDAT(a6)		| Send track to WD1772
+		moveq.l	#FL_SV,d6		| Seek/verify command
+		bsr	flopcmds		| Send command to floppy
+		bne	reseek01		| Jump if error occurred
+
+		move.w	ctrack(a5),0(a1)	| Update track number in dsb
+		and.b	#0x18,d7		| Test for RNF, CRC, LOST
+
+reseek01:	rts				| Return to caller
+
+		.page
+
+| restore -- Restore to track 0
+| -------    ------------------
+restore:	clr.w	d6			| Restore command
+		bsr	flopcmds		| Send to WD1772
+		bne	restor01		| Jump if an error occurred
+
+		btst	#2,d7			| Check track 0 bit
+		eori	#0004,sr		| Invert Z flag in 680000 sr
+		bne	restor01		| Jump if not track 0
+
+		clr.w	0(a1)			| Set track = 0 in dsb
+
+restor01:	rts				| Return to caller
+
+| flopcmds -- Send command to WD1772 floppy controller
+| --------    ----------------------------------------
+flopcmds:	move.w	2(a1),d0		| Get seek rate from dsb
+		and.b	#0x3,d0			| ...
+		or.b	d0,d6			| OR into command word
+		move.l	#0x40000,d7		| Set timeout counter
+		btst	#7,DSKCMD(a6)		| Motor on ?
+		bne	flopcm01		| Jump if so
+
+		move.l	#0x60000,d7		| Set longer timeout count
+
+flopcm01:	move.b	d6,DSKCMD(a6)		| Write command from d6
+
+		move.l	#0x1000,d0		| Set initial busy timeout in d0
+
+flopcm04:	btst	#0,DSKCMD(a6)		| Controller busy yet ?
+		bne	flopcm02		| Jump if so
+
+		subq.l	#1,d0			| Decrement timeout counter
+		beq	flopcm03		| Jump if timed out
+
+		bra	flopcm04		| Wait for busy some more
+
+flopcm02:	subq.l	#1,d7			| Decrement timeout counter
+		beq	flopcm03		| Jump if timed out
+
+		btst	#0,DSKCMD(a6)		| WD1772 done ?
+		bne	flopcm02		| Jump if not
+
+		clr.l	d7			| Clear out upper bits of d7
+		move.b	DSKCMD(a6),d7		| Read status into LS byte of d7
+		clr.l	d6			| Clear error flag in d6
+		rts				| Return to caller
+
+flopcm03:	bsr	rs1772			| Reset WD1772  (end transfer)
+		moveq.l	#1,d6			| Set error flag in d6
+		rts				| Return to caller
+
+		.page
+
+| rs1772 -- Reset WD1772 floppy controller
+| ------    ------------------------------
+rs1772:		move.b	#FL_FR,DSKCMD(a6)	| Send reset to WD1772
+		move.w	#15,d7			| Set delay count
+
+rs1772a:	dbf	d7,rs1772a		| Delay a while
+		rts				| Return to caller
+
+| select -- Select drive and side
+| ------    ----------------------
+select:		move.w	sr,-(a7)		| Save sr on stack
+		ori.w	#IPL7,sr		| Disable interrupts
+		clr.w	deslflag(a5)		| Clear deselect flag
+		move.b	mc1iorec+cfr1,d0	| Get current MC1 cfr1 image
+		ori.b	#1,d0			| Select drive  (we only have 1)
+		move.b	d0,mc1iorec+cfr1	| Store updated image
+		move.b	d0,MC1ACIA+ACIA_CFR	| Send it to the MC1 ACIA
+		move.w	cside(a5),d0		| Get side number  (LS bit)
+		and.w	#1,d0			| Mask off garbage bits
+		andi.b	#0xFE,mc2iorec+cfr1	| Mask off D0 in MC2 cfr1 image
+		or.b	mc2iorec+cfr1,d0	| OR side with mc2iorec cfr1
+		move.b	d0,mc2iorec+cfr1	| Store updated cfr1 image
+		move.b	d0,MC2ACIA+ACIA_CFR	| Send it to the MC2 ACIA
+		move.w	(a7)+,sr		| Restore interrupts
+		move.w	0(a1),d7		| Get track from dsb
+		move.b	d7,DSKTRK(a6)		| Send it to the WD1772
+		clr.b	tmpdma(a5)		| Clear bits 31..24 of tmpdma
+
+select1:	move.w	csect(a5),d7		| Get sector number
+		move.b	d7,DSKSEC(a6)		| Send it to the WD1772
+		move.l	cdma(a5),a0		| Setup transfer address in a0
+		rts				| Return to caller
+
+		.page
+
+| change -- Check for disk change status
+| ------    ----------------------------
+change:		cmp.w	#1,nflops		| Check # of floppies
 		bne	change02
-*
-		move.w	16(a7),d0		* Drive number to d0
+
+		move.w	16(a7),d0		| Drive number to d0
 		cmp.w	disknum,d0
-		beq	change01		* Jump if =
-*
-		move.w	d0,-(a7)		* Stack drive number
-		move.w	#ERR17,-(a7)		* Stack error code
-		bsr	criter			* Do critical error routine
-		addq.w	#4,a7			* Cleanup stack
-		move.w	#$FFFF,wplatch		* Status for drives = "unsure"
-		move.w	16(a7),disknum		* Save disk number
-*
-change01:	clr.w	16(a7)			* Clear disk number
-*
-change02:	rts				* Return to caller
-*
-* setdmode -- Set drive change mode
-* --------    ---------------------
-setdmode:	lea	dskmode,a0		* Point at disk mode table
-		move.b	d0,-(a7)		* Save mode on stack
-		move.w	cdev(a5),d0		* Get drive number
-		move.b	(a7)+,0(a0,d0)		* Set drive mode / cleanup stack
-		rts				* Return to caller
-*
-		.page
-*
-* bootload -- Load boot sector
-* --------    ----------------
-bootload:	link	a6,#0			* Link stack frames
-		movem.l	d6-d7,-(a7)		* Save registers
-		jsr	_hdvini			* Init drive
-		tst.w	nflops			* See if any connected
-		beq	bootld01		* Jump if drive there
-*
-		moveq.l	#1,d0			* "couldn't load"
+		beq	change01		| Jump if =
+
+		move.w	d0,-(a7)		| Stack drive number
+		move.w	#ERR17,-(a7)		| Stack error code
+		bsr	criter			| Do critical error routine
+		addq.w	#4,a7			| Cleanup stack
+		move.w	#0xFFFF,wplatch		| Status for drives = "unsure"
+		move.w	16(a7),disknum		| Save disk number
+
+change01:	clr.w	16(a7)			| Clear disk number
+
+change02:	rts				| Return to caller
+
+| setdmode -- Set drive change mode
+| --------    ---------------------
+setdmode:	lea	dskmode,a0		| Point at disk mode table
+		move.b	d0,-(a7)		| Save mode on stack
+		move.w	cdev(a5),d0		| Get drive number
+		move.b	(a7)+,0(a0,d0)		| Set drive mode / cleanup stack
+		rts				| Return to caller
+
+		.page
+
+| bootload -- Load boot sector
+| --------    ----------------
+bootload:	link	a6,#0			| Link stack frames
+		movem.l	d6-d7,-(a7)		| Save registers
+		jsr	_hdvini			| Init drive
+		tst.w	nflops			| See if any connected
+		beq	bootld01		| Jump if drive there
+
+		moveq.l	#1,d0			| "couldn't load"
 		bra	bootld02
-*
-bootld01:	moveq.l	#2,d0			* "no drive connected"
-*
-bootld02:	move.w	d0,d7			* Save possible error in d7
+
+bootld01:	moveq.l	#2,d0			| "no drive connected"
+
+bootld02:	move.w	d0,d7			| Save possible error in d7
 		tst.w	nflops
 		beq	bootld04
-*
+
 		cmp.w	#2,bootdev
 		bge	bootld04
-*
-		move.w	#1,(a7)			* Sector count = 1,
-		clr.w	-(a7)			* ... side = 0,
-		clr.w	-(a7)			* ... track = 0,
-		move.w	#1,-(a7)		* ... sector = 1,
-		move.w	bootdev,-(a7)		* ... drive = bootdev,
-		clr.l	-(a7)			* ... filler,
-		move.l	#buffer,-(a7)		* ... buffer address
-		jsr	floprd			* Read the sector
-		add.l	#16,a7			* Cleanup stack
-		tst.l	d0			* Error ?
-		bne	bootld03		* Jump if not
-*
+
+		move.w	#1,(a7)			| Sector count = 1,
+		clr.w	-(a7)			| ... side = 0,
+		clr.w	-(a7)			| ... track = 0,
+		move.w	#1,-(a7)		| ... sector = 1,
+		move.w	bootdev,-(a7)		| ... drive = bootdev,
+		clr.l	-(a7)			| ... filler,
+		move.l	#buffer,-(a7)		| ... buffer address
+		jsr	floprd			| Read the sector
+		add.l	#16,a7			| Cleanup stack
+		tst.l	d0			| Error ?
+		bne	bootld03		| Jump if not
+
 		clr.w	d7
 		bra	bootld04
-*
+
 bootld03:	tst.b	wpstatus
 		bne	bootld04
-*
-		moveq.l	#3,d0			* "unreadable"
+
+		moveq.l	#3,d0			| "unreadable"
 		bra	bootld07
-*
+
 bootld04:	tst.w	d7
 		beq	bootld05
-*
-		move.w	d7,d0			* Get old error code
+
+		move.w	d7,d0			| Get old error code
 		bra	bootld07
-*
-		.page
-*
-bootld05:	move.w	#256,(a7)		* Set count for 256 words
-		move.l	#buffer,-(a7)		* Point at buffer
-		bsr	chksum			* Calculate checksum
-		addq.l	#4,a7			* Cleanup stack
-		cmp.w	#$1234,d0		* Boot sector checksum ?
-		bne	bootld06		* Jump if not
-*
-		clr.w	d0			* Set flag for OK
-		move.w	bootdev,booted		* Save last boot device
+
+		.page
+
+bootld05:	move.w	#256,(a7)		| Set count for 256 words
+		move.l	#buffer,-(a7)		| Point at buffer
+		bsr	chksum			| Calculate checksum
+		addq.l	#4,a7			| Cleanup stack
+		cmp.w	#0x1234,d0		| Boot sector checksum ?
+		bne	bootld06		| Jump if not
+
+		clr.w	d0			| Set flag for OK
+		move.w	bootdev,booted		| Save last boot device
 		bra	bootld07
-*
-bootld06:	moveq.l	#4,d0			* "not valid boot sector"
-*
+
+bootld06:	moveq.l	#4,d0			| "not valid boot sector"
+
 bootld07:	tst.l	(a7)+
-		movem.l	(a7)+,d7		* Restore registers
+		movem.l	(a7)+,d7		| Restore registers
 		unlk	a6
-		rts				* Return to caller
-*
-		.page
-*
-* chksum -- caluculate checksum
-* ------    -------------------
+		rts				| Return to caller
+
+		.page
+
+| chksum -- caluculate checksum
+| ------    -------------------
 chksum:		link	a6,#0
-		movem.l	d6-d7,-(a7)		* Preserve registers
-		clr.w	d7			* Clear sum
-		bra	chksum02		* Jump into loop
-*
-chksum01:	move.l	8(a6),a0		* Get buffer address
-		move.w	(a0),d0			* Get word
-		add.w	d0,d7			* Add to checksum in d7
-		addq.l	#2,8(a6)		* Update buffer address
-*
-chksum02:	move.w	12(a6),d0		* Get word count
-		subq.w	#1,12(a6)		* Decrement it
-		tst.w	d0			* Done ?
-		bne	chksum01		* Loop if not
-*
-		move.w	d7,d0			* Put result in d0
+		movem.l	d6-d7,-(a7)		| Preserve registers
+		clr.w	d7			| Clear sum
+		bra	chksum02		| Jump into loop
+
+chksum01:	move.l	8(a6),a0		| Get buffer address
+		move.w	(a0),d0			| Get word
+		add.w	d0,d7			| Add to checksum in d7
+		addq.l	#2,8(a6)		| Update buffer address
+
+chksum02:	move.w	12(a6),d0		| Get word count
+		subq.w	#1,12(a6)		| Decrement it
+		tst.w	d0			| Done ?
+		bne	chksum01		| Loop if not
+
+		move.w	d7,d0			| Put result in d0
 		tst.l	(a7)+
-		movem.l	(a7)+,d7		* Restore registers
+		movem.l	(a7)+,d7		| Restore registers
 		unlk	a6
-		rts				* Return to caller
-*
-		.page
-*
-* mult32 -- 32 bit signed multiply
-* ------    ----------------------
+		rts				| Return to caller
+
+		.page
+
+| mult32 -- 32 bit signed multiply
+| ------    ----------------------
 mult32:		link	a6,#-4
 		clr.w	d2
 		tst.l	8(a6)
 		bge	mult32a
-*
+
 		neg.l	8(a6)
 		addq.w	#1,d2
-*
+
 mult32a:	tst.l	12(a6)
 		bge	mult32b
-*
+
 		neg.l	12(a6)
 		addq.w	#1,d2
-*
+
 mult32b:	move.w	10(a6),d0
 		mulu	14(a6),d0
